import { b as _extends, d as _inheritsLoose } from './chunk-fb907809.js';
import React from 'react';
import PropTypes from 'prop-types';
import { prop } from 'styled-tools';
import styled from './styled.js';
import as from './as.js';
import Hidden from './Hidden.js';
import { c as HiddenToggle, b as HiddenShow, a as HiddenHide } from './chunk-8c2a75f5.js';
import { a as StepContainer, b as StepNext, c as StepPrevious } from './chunk-b88233e8.js';
import 'styled-components';
import './chunk-a7ce379e.js';
import 'react-dom';
import 'hoist-non-react-statics';
import './chunk-d8771a86.js';
import './Base.js';
import './chunk-254efadd.js';
import './chunk-6f5c362f.js';
import 'constate';

var noop = function noop() {
  return false;
};

var Component =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Component, _React$Component);

  function Component(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    var _this$props = _this.props,
        register = _this$props.register,
        step = _this$props.step,
        order = _this$props.order;
    register(step, order);
    return _this;
  }

  var _proto = Component.prototype;

  _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
    var _this$props2 = this.props,
        step = _this$props2.step,
        update = _this$props2.update,
        order = _this$props2.order;

    if (prevProps.step !== step || prevProps.order !== order) {
      update(prevProps.step, step, order);
    }
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    var _this$props3 = this.props,
        step = _this$props3.step,
        unregister = _this$props3.unregister;
    unregister(step);
  };

  _proto.render = function render() {
    var _this$props4 = this.props,
        isCurrent = _this$props4.isCurrent,
        step = _this$props4.step;
    return React.createElement(Hidden, _extends({
      unmount: true,
      visible: isCurrent(step)
    }, this.props));
  };

  return Component;
}(React.Component);

var Step = styled(Component).withConfig({
  displayName: "Step"
})(["", ";"], prop("theme.Step"));
Step.propTypes = {
  step: PropTypes.string.isRequired,
  register: PropTypes.func.isRequired,
  update: PropTypes.func.isRequired,
  unregister: PropTypes.func.isRequired,
  isCurrent: PropTypes.func.isRequired,
  order: PropTypes.number
};
Step.defaultProps = {
  register: noop,
  update: noop,
  unregister: noop,
  isCurrent: noop
};
var Step$1 = as("div")(Step);

var toggle = function toggle(props) {
  return function () {
    return props.toggle && props.toggle(props.step);
  };
};

var Component$1 = function Component(props) {
  return React.createElement(HiddenToggle, _extends({}, props, {
    toggle: toggle(props)
  }));
};

var StepToggle = styled(Component$1).withConfig({
  displayName: "StepToggle"
})(["", ";"], prop("theme.StepToggle"));
StepToggle.propTypes = {
  toggle: PropTypes.func.isRequired,
  step: PropTypes.string.isRequired
};
var StepToggle$1 = as("button")(StepToggle);

var show = function show(props) {
  return function () {
    return props.show && props.show(props.step);
  };
};

var Component$2 = function Component(props) {
  return React.createElement(HiddenShow, _extends({}, props, {
    show: show(props)
  }));
};

var StepShow = styled(Component$2).withConfig({
  displayName: "StepShow"
})(["", ";"], prop("theme.StepShow"));
StepShow.propTypes = {
  show: PropTypes.func.isRequired,
  step: PropTypes.string.isRequired
};
var StepShow$1 = as("button")(StepShow);

var StepHide = styled(HiddenHide).withConfig({
  displayName: "StepHide"
})(["", ";"], prop("theme.StepHide"));
var StepHide$1 = as("button")(StepHide);

Step$1.Container = StepContainer;
Step$1.Toggle = StepToggle$1;
Step$1.Show = StepShow$1;
Step$1.Hide = StepHide$1;
Step$1.Next = StepNext;
Step$1.Previous = StepPrevious;

export default Step$1;
