'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var styledTools = require('styled-tools');
var __chunk_3 = require('./chunk-f0c301b2.js');
var __chunk_1 = require('./chunk-582bef72.js');
var React = _interopDefault(require('react'));
var ReactDOM = require('react-dom');
var ReactDOM__default = _interopDefault(ReactDOM);
var PropTypes = _interopDefault(require('prop-types'));
var hoistNonReactStatics = _interopDefault(require('hoist-non-react-statics'));
var __chunk_4 = require('./chunk-25591e69.js');
var styled = require('./styled.js');
var as = require('./as.js');
var Base = require('./Base.js');
var __chunk_5 = require('./chunk-0d990809.js');
var __chunk_6 = require('./chunk-cf768852.js');
require('styled-components');
require('./chunk-67afb756.js');
require('constate');

var hasTransition = function hasTransition(props) {
  return Boolean(props.animated || props.fade || props.slide || props.expand);
};
var translate3d = function translate3d(x, y, z) {
  return "translate3d(" + __chunk_3.numberToPx(x) + ", " + __chunk_3.numberToPx(y) + ", " + __chunk_3.numberToPx(z) + ")";
};
var origin = function origin(x, y) {
  if (x === void 0) {
    x = "center";
  }

  if (y === void 0) {
    y = "center";
  }

  return __chunk_3.numberToPx(x) + " " + __chunk_3.numberToPx(y);
};
var calc = function calc(a, b) {
  return "calc(" + __chunk_3.numberToPx(a) + " + " + __chunk_3.numberToPx(b) + ")";
};
var minus = function minus(v) {
  return "-" + __chunk_3.numberToPx(v);
};
var expand = styledTools.ifProp({
  expand: true
}, styledTools.prop("defaultExpand", "center"), styledTools.prop("expand"));
var slide = styledTools.ifProp({
  slide: true
}, styledTools.prop("defaultSlide", "right"), styledTools.prop("slide"));
var scaleWithProps = styledTools.ifProp("expand", "scale(0.01)");
var originWithProps = styledTools.withProp(["originX", "originY"], function (x, y) {
  return styledTools.switchProp(expand, {
    center: origin(calc("50%", x), calc("50%", y)),
    top: origin(calc("50%", x), calc("100%", y)),
    right: origin(x, calc("50%", y)),
    bottom: origin(calc("50%", x), y),
    left: origin(calc("100%", x), calc("50%", y))
  }, origin(calc("50%", x), calc("50%", y)));
});
var translateWithProps = styledTools.withProp(["translateX", "translateY"], translate3d);
var slideWithProps = styledTools.withProp(["translateX", "translateY", "slideOffset"], function (x, y, offset) {
  if (offset === void 0) {
    offset = "100%";
  }

  return styledTools.switchProp(slide, {
    top: translate3d(x, calc(offset, y)),
    right: translate3d(calc(minus(offset), x), y),
    bottom: translate3d(x, calc(minus(offset), y)),
    left: translate3d(calc(offset, x), y)
  }, translate3d(x, y));
});

var Component =
/*#__PURE__*/
function (_React$Component) {
  __chunk_1._inheritsLoose(Component, _React$Component);

  function Component() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "state", {
      visible: _this.props.visible,
      transitioning: _this.props.transitioning
    });

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "applyState", function () {
      var _this$props = _this.props,
          visible = _this$props.visible,
          unmount = _this$props.unmount;

      if (typeof window !== "undefined" && unmount && hasTransition(_this.props)) {
        if (visible) {
          _this.setState({
            transitioning: true
          });

          window.requestAnimationFrame(function () {
            return _this.setState({
              transitioning: false,
              visible: true
            });
          });
        } else {
          _this.setState({
            visible: false,
            transitioning: true
          });
        }
      } else {
        _this.setState({
          visible: visible
        });
      }
    });

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "handleTransitionEnd", function () {
      var _this$props2 = _this.props,
          visible = _this$props2.visible,
          unmount = _this$props2.unmount;

      if (!visible && unmount) {
        _this.setState({
          transitioning: false
        });
      }
    });

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "handleKeyDown", function (e) {
      var _this$props3 = _this.props,
          visible = _this$props3.visible,
          hide = _this$props3.hide;

      if (e.key === "Escape" && visible && hide) {
        hide();
      }
    });

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "handleClickOutside", function (e) {
      var node = ReactDOM.findDOMNode(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)));
      var _this$props4 = _this.props,
          hide = _this$props4.hide,
          visible = _this$props4.visible;
      var shouldHide = node && !node.contains(e.target) && visible && hide;

      if (shouldHide) {
        setTimeout(function () {
          return _this.props.visible && hide();
        });
      }
    });

    return _this;
  }

  var _proto = Component.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this$props5 = this.props,
        hideOnEsc = _this$props5.hideOnEsc,
        hideOnClickOutside = _this$props5.hideOnClickOutside;

    if (hideOnEsc) {
      document.body.addEventListener("keydown", this.handleKeyDown);
    }

    if (hideOnClickOutside) {
      document.body.addEventListener("click", this.handleClickOutside);
    }
  };

  _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
    if (prevProps.visible !== this.props.visible) {
      this.applyState();
    }
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    document.body.removeEventListener("keydown", this.handleKeyDown);
    document.body.removeEventListener("click", this.handleClickOutside);
  };

  _proto.render = function render() {
    var _this$props6 = this.props,
        unmount = _this$props6.unmount,
        onTransitionEnd = _this$props6.onTransitionEnd;
    var _this$state = this.state,
        visible = _this$state.visible,
        transitioning = _this$state.transitioning;

    if (unmount && !visible && !transitioning) {
      return null;
    }

    return React.createElement(Base.default, __chunk_1._extends({
      "aria-hidden": !visible
    }, this.props, this.state, {
      onTransitionEnd: __chunk_4.callAll(this.handleTransitionEnd, onTransitionEnd)
    }));
  };

  return Component;
}(React.Component);

hoistNonReactStatics(Component, Base.default);
var Hidden = styled.default(Component).withConfig({
  displayName: "Hidden"
})(["transform:", ";", ";&[aria-hidden=\"true\"]{pointer-events:none;", ";", ";}", ";"], translateWithProps, styledTools.ifProp(hasTransition, styled.css(["transform-origin:", ";transition:all ", " ", " ", ";"], originWithProps, styledTools.prop("duration"), styledTools.prop("timing"), styledTools.prop("delay"))), styledTools.ifProp("fade", "opacity: 0"), styledTools.ifProp(hasTransition, styled.css(["transform:", " ", ";visibility:hidden;"], slideWithProps, scaleWithProps), "display: none !important"), styledTools.prop("theme.Hidden"));
Hidden.propTypes = {
  visible: PropTypes.bool,
  hide: PropTypes.func,
  hideOnEsc: PropTypes.bool,
  hideOnClickOutside: PropTypes.bool,
  unmount: PropTypes.bool,
  fade: PropTypes.bool,
  expand: PropTypes.oneOfType([PropTypes.bool, PropTypes.oneOf(["center", "top", "right", "bottom", "left"])]),
  slide: PropTypes.oneOfType([PropTypes.bool, PropTypes.oneOf(["top", "right", "bottom", "left"])]),
  duration: PropTypes.string,
  delay: PropTypes.string,
  timing: PropTypes.string,
  animated: PropTypes.bool
};
Hidden.defaultProps = {
  duration: "250ms",
  timing: "ease-in-out"
};
var Hidden$1 = as.default("div")(Hidden);

Hidden$1.Container = __chunk_5.HiddenContainer;
Hidden$1.Hide = __chunk_6.HiddenHide;
Hidden$1.Show = __chunk_6.HiddenShow;
Hidden$1.Toggle = __chunk_6.HiddenToggle;

exports.default = Hidden$1;
