'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-582bef72.js');
var React = _interopDefault(require('react'));
var PropTypes = _interopDefault(require('prop-types'));
var constate = require('constate');
var styled = require('./styled.js');
require('styled-components');

var Provider = function Provider(_ref) {
  var theme = _ref.theme,
      children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["theme", "children"]);

  return React.createElement(constate.Provider, props, theme ? React.createElement(styled.ThemeProvider, {
    theme: theme
  }, children) : children);
};

Provider.propTypes = {
  initialState: PropTypes.object,
  onMount: PropTypes.func,
  onUpdate: PropTypes.func,
  onUnmount: PropTypes.func,
  theme: PropTypes.oneOfType([PropTypes.object, PropTypes.func]),
  children: PropTypes.node,
  devtools: PropTypes.bool
};

exports.default = Provider;
