'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-582bef72.js');
var React = _interopDefault(require('react'));
var PropTypes = _interopDefault(require('prop-types'));
var styledTools = require('styled-tools');
var styled = require('./styled.js');
var as = require('./as.js');
var Hidden = require('./Hidden.js');
var __chunk_6 = require('./chunk-cf768852.js');
var __chunk_9 = require('./chunk-d4dd0cf4.js');
require('styled-components');
require('./chunk-f0c301b2.js');
require('react-dom');
require('hoist-non-react-statics');
require('./chunk-25591e69.js');
require('./Base.js');
require('./chunk-67afb756.js');
require('./chunk-0d990809.js');
require('constate');

var noop = function noop() {
  return false;
};

var Component =
/*#__PURE__*/
function (_React$Component) {
  __chunk_1._inheritsLoose(Component, _React$Component);

  function Component(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    var _this$props = _this.props,
        register = _this$props.register,
        step = _this$props.step,
        order = _this$props.order;
    register(step, order);
    return _this;
  }

  var _proto = Component.prototype;

  _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
    var _this$props2 = this.props,
        step = _this$props2.step,
        update = _this$props2.update,
        order = _this$props2.order;

    if (prevProps.step !== step || prevProps.order !== order) {
      update(prevProps.step, step, order);
    }
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    var _this$props3 = this.props,
        step = _this$props3.step,
        unregister = _this$props3.unregister;
    unregister(step);
  };

  _proto.render = function render() {
    var _this$props4 = this.props,
        isCurrent = _this$props4.isCurrent,
        step = _this$props4.step;
    return React.createElement(Hidden.default, __chunk_1._extends({
      unmount: true,
      visible: isCurrent(step)
    }, this.props));
  };

  return Component;
}(React.Component);

var Step = styled.default(Component).withConfig({
  displayName: "Step"
})(["", ";"], styledTools.prop("theme.Step"));
Step.propTypes = {
  step: PropTypes.string.isRequired,
  register: PropTypes.func.isRequired,
  update: PropTypes.func.isRequired,
  unregister: PropTypes.func.isRequired,
  isCurrent: PropTypes.func.isRequired,
  order: PropTypes.number
};
Step.defaultProps = {
  register: noop,
  update: noop,
  unregister: noop,
  isCurrent: noop
};
var Step$1 = as.default("div")(Step);

var toggle = function toggle(props) {
  return function () {
    return props.toggle && props.toggle(props.step);
  };
};

var Component$1 = function Component(props) {
  return React.createElement(__chunk_6.HiddenToggle, __chunk_1._extends({}, props, {
    toggle: toggle(props)
  }));
};

var StepToggle = styled.default(Component$1).withConfig({
  displayName: "StepToggle"
})(["", ";"], styledTools.prop("theme.StepToggle"));
StepToggle.propTypes = {
  toggle: PropTypes.func.isRequired,
  step: PropTypes.string.isRequired
};
var StepToggle$1 = as.default("button")(StepToggle);

var show = function show(props) {
  return function () {
    return props.show && props.show(props.step);
  };
};

var Component$2 = function Component(props) {
  return React.createElement(__chunk_6.HiddenShow, __chunk_1._extends({}, props, {
    show: show(props)
  }));
};

var StepShow = styled.default(Component$2).withConfig({
  displayName: "StepShow"
})(["", ";"], styledTools.prop("theme.StepShow"));
StepShow.propTypes = {
  show: PropTypes.func.isRequired,
  step: PropTypes.string.isRequired
};
var StepShow$1 = as.default("button")(StepShow);

var StepHide = styled.default(__chunk_6.HiddenHide).withConfig({
  displayName: "StepHide"
})(["", ";"], styledTools.prop("theme.StepHide"));
var StepHide$1 = as.default("button")(StepHide);

Step$1.Container = __chunk_9.StepContainer;
Step$1.Toggle = StepToggle$1;
Step$1.Show = StepShow$1;
Step$1.Hide = StepHide$1;
Step$1.Next = __chunk_9.StepNext;
Step$1.Previous = __chunk_9.StepPrevious;

exports.default = Step$1;
