'use strict';

var __chunk_3 = require('./chunk-f0c301b2.js');

var kebabCase = function kebabCase(str) {
  return str.replace(/([a-z])([A-Z])/g, "$1-$2") // fooBar -> foo-Bar
  .replace(/[_]/g, "-") // _ -> - to use \W later on, it includes _.
  .replace(/\W+/g, "-") // ----foo  bar => -foo-bar
  .replace(/^\W|\W$/g, "") // "a-d-" => "a-d"
  .toLowerCase();
};

var bool = function bool(cssProp, validComponentProps) {
  return function (props) {
    var keys = Object.keys(props).filter(function (k) {
      return validComponentProps.indexOf(k) >= 0;
    }).filter(function (k) {
      return !!props[k];
    }).map(kebabCase);

    if (keys.length) {
      return cssProp + ": " + keys.join(" ") + ";";
    }

    return "";
  };
};
var value = function value(cssProp, componentProp) {
  return function (props) {
    var v = props[componentProp];
    if (typeof v === "undefined") return "";
    return cssProp + ": " + __chunk_3.numberToPx(v) + ";";
  };
};

exports.bool = bool;
exports.value = value;
